package ;

import flash.ui.Mouse;
import flixel.group.FlxGroup;
import openfl.Assets;
import flash.display.BitmapData;
import flash.display.StageQuality;
import flash.events.Event;
import flash.geom.Point;
import flash.geom.Rectangle;
import flash.Lib;
import flash.text.AntiAliasType;
import flash.text.Font;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flash.text.TextFieldType;
import flash.text.TextFormat;
import flash.system.Capabilities;
import flash.utils.ByteArray;
import flixel.FlxCamera;
import flixel.FlxG;
import flixel.FlxGame;
import flixel.FlxState;

//Basically Main (FlxGame)
class GameClass extends FlxGame
{
	inline static var BASEFONTSIZE = 10;
	public inline static var BASEWIDTH = 240;
	public inline static var BASEHEIGHT = 320;
	var m_unscaledWidth:Int;
	var m_unscaledHeight:Int;
	var m_scale:Float = 2.0;
	var capX:Float;
	var capY:Float;
	var stageX:Float;//just for feedback
	var stageY:Float;
	var m_font:Font;//to get the fontname crossplatform
	var m_defaultTextFormat:TextFormat;
	public static var m_instance:GameClass;
	//objects
	public var m_stats:Array<CharacterStats> = null;
	public var m_playerStats:CharacterStats = null;
	public var m_things:Array<String> = null;
	public var m_invitations:Array<CharacterStats>=null;
	
	public function new()
	{
		m_instance = this;
		//initialize all size dependent things
		//stage size is flipped as well..
		//if (Lib.current.stage.stageWidth > Lib.current.stage.stageHeight)
		{
			stageX = Lib.current.stage.stageWidth;
			stageY = Lib.current.stage.stageHeight;
		}
		//else
		//{
		//	stageX = Lib.current.stage.stageHeight;
		//	stageY = Lib.current.stage.stageWidth;
		//}
		#if mobile
		//ehrm yeah... it flips the resolutions sometimes, no matter if you put in landscape or not...
		if (Capabilities.screenResolutionX > Capabilities.screenResolutionY)
		{
			capX = Capabilities.screenResolutionX;
			capY = Capabilities.screenResolutionY;
		}
		else
		{
			capX = Capabilities.screenResolutionY;
			capY = Capabilities.screenResolutionX;
		}
		CalcUnscaledSizes(Std.int(capX), Std.int(capY));
		#else
		CalcUnscaledSizes(Std.int(stageX), Std.int(stageY));//needs to be stage for flash (capabilities worked on android)
		#end
		m_font = Assets.getFont("assets/data/nokiafc22.ttf");//"assets_droidsans_ttf"
		m_defaultTextFormat = new TextFormat(m_font.fontName, BASEFONTSIZE * m_scale, 0xff000000, false, false, false, null, null, null, 0, 0, 0, 0);
		super(m_unscaledWidth, m_unscaledHeight, MenuState, m_scale, 30, 30);// , true);//we handle all mouse stuff ourselves, a lot more responsive
		//FlxG.mouse.useSystemCursor = true; still null, gets set on added to stage
		//this.forceDebugger = true;
		Lib.current.stage.quality = StageQuality.LOW;//FIXME: test changes to this, Font is affected but can be overridden with antialiastype, otherwise I see no changes so far
		//fullscreen can not always be set programmatically, Lib.current.stage.displayState, not really needed it seems
		Lib.current.stage.addEventListener(Event.RESIZE, OnResize);// , false, 0, true);
		FlxG.log.redirectTraces = false;//don't redirect traces to flixel debugger

		//general object initialization, this should probably be done before initializing game but anything visual.. gets destroyed by switchstate... FIXME
		m_things = ["play a game", "do sports", "lie in the grass", "do homework", "go shopping", "watch a movie", "look at cars", "listen to music", "learn a recipe/cook something", "go to art gallery"];
		m_stats = new Array();
		var names:Array<String> = ["Tobias", "Janosch", "Iwan", "Martha", "Sjors", "Christiaan", "Rita", "Ludwig", "Max", "Andree", "Fabian", "Andy", "Addy", "Benjamin", "Christian"];
		for (i in 0...6)
		{
			var pos:Int = Math.floor(Math.random() * names.length);
			var p:CharacterStats = new CharacterStats(names.splice(pos, 1)[0]);
			m_stats.push(p);
		}
		m_playerStats = new CharacterStats("You",true);
	}
	
	private function CalcUnscaledSizes(w:Int,h:Int):Void
	{
		var sX:Float = w / BASEWIDTH;
		var sY:Float = h / BASEHEIGHT;
		//basing scaling on stage seems to mess up on android, not really, that was probably due to the reversed screen resolution
		//var sX:Float = Lib.current.stage.stageWidth/BASEWIDTH;
		//var sY:Float = Lib.current.stage.stageHeight/BASEHEIGHT;
		m_scale = sX;
		m_unscaledWidth = BASEWIDTH;
		m_unscaledHeight = BASEHEIGHT;
		if (sX != sY)
		{
			if (sX < sY)
			{
				//pixels leftover in height
				//m_scale = sX;
				//1280/640=2 & 1024/480=2,13 Cap.screenResY-(scale*UNSCALEDHEIGHT) 1024-(2*480)=64/2=32 +480=512
				m_unscaledHeight = Math.ceil((BASEHEIGHT / m_scale) * sY);
			}
			else
			{
				//pixels leftover in width
				m_scale = sY;
				m_unscaledWidth = Math.ceil((BASEWIDTH / m_scale) * sX);
			}
		}
		//trace("unscaled: " + m_unscaledWidth + " x " + m_unscaledHeight);
		//trace("stage: "+Lib.current.stage.stageWidth + "x" + Lib.current.stage.stageHeight);
	}
	
	private function OnResize(e:Event):Void
	{
		//_debugger.log.add("resizeevent!: "+Lib.current.stage.stageWidth+"x"+Lib.current.stage.stageHeight);
		CalcUnscaledSizes(Lib.current.stage.stageWidth, Lib.current.stage.stageHeight);
		FlxG.resizeGame(m_unscaledWidth, m_unscaledHeight);
		//FlxG.width = m_unscaledWidth;
		//FlxG.height = m_unscaledHeight;
		FlxCamera.defaultZoom = m_scale;
		//camera's should be dealt with by the creators of the camera's themselves.
		//FlxG.camera.zoom = m_scale;
		//FlxG.resetCameras();
		//FIXME: debugger & soundtray & clickablearea also need update
		//trace(Lib.current.stage.stageWidth + "x" + Lib.current.stage.stageHeight+"->"+m_unscaledWidth+"x"+m_unscaledHeight);
		m_defaultTextFormat.size = BASEFONTSIZE * m_scale;
	}
	
	inline public function GetScale():Float { return m_scale; }
	
	inline public function GetTextFormat():TextFormat {	return m_defaultTextFormat; }
	
	public function CreateTextField():TextField
	{
		var f:TextField = new TextField();
		f.embedFonts = true;
		f.defaultTextFormat=m_defaultTextFormat;//TODO: do we add a listener to the field? to automatically adjust the format on resize? 
		f.multiline=true;
		f.background=true;
		f.backgroundColor=0xffffffff;
		f.autoSize=TextFieldAutoSize.NONE;
		f.border = false;
		f.wordWrap = true;
		f.type = TextFieldType.INPUT;
		f.mouseEnabled = true;
		f.selectable = true;
		f.antiAliasType = AntiAliasType.ADVANCED;
		return f;
	}
	
	//BUGFIX: this causes the maxScrollV member to be updated instantaneously. Reading textHeight does not work in all cases as a bugfix but native code does not have getcharbounds...
	public static function DoTextFieldUpdateBugFix(field:TextField):Void
	{
		#if flash
		field.getCharBoundaries(0);
		#else
		field.textHeight;
		#end
	}
	
	//not available on native
	public static function GetLineIndexOfChar(field:TextField,charIndex:Int):Int
	{
		if (charIndex<0 || charIndex>field.text.length-1) return -1;
		for (i in 0...field.numLines)
		{
			if (field.getLineOffset(i) > charIndex) return i - 1;
		}
		return field.numLines - 1;
	}
	
	//not available on native
	//xPos & yPos are in field coordinate space, like field.mouseX.
	public static function GetLineIndexAtPoint(field:TextField, xPos:Float, yPos:Float):Int
	{
		if (yPos < 0 || xPos < 0 || yPos > field.height || xPos > field.width || field.text=="") return -1;
		var avgLineHeight:Float = (field.textHeight / field.numLines);
		var index:Int = Math.floor(yPos / avgLineHeight);// - (field.scrollV - 1);
		if (index > (field.bottomScrollV - field.scrollV)) index = -1;
		else index += field.scrollV-1;
		return index;
	}
	
	//BUGFIX: sometimes flash does not actually update parameters like width & height until one or more frames later, like after setting the scrollrect. This forces all width & height parameters to be updated right fucking now.
	inline public static function ForceSizeUpdate():Void { new BitmapData(1,1).draw(Lib.current.stage); }
	
	public static function RandomizeArray(a:Array<Dynamic>):Array<Dynamic>
	{
		//switches values around
		for (i in 0...a.length)
		{
			var tmp:Dynamic=a[i];
			var randomNum:Int=Math.floor(Math.random()*a.length);
			a[i]=a[randomNum];
			a[randomNum]=tmp;
		}
		return a;
	}
	
	//returns new point on a quadratic curve, p0 start, p1 is the control point, p2 end, t=0(begin)-1(end)
	public static inline function GetPointOnCurve(p0:Point, p1:Point, p2:Point, t:Float):Point
	{
		var negT:Float = 1 - t;
		return new Point((Math.pow(negT, 2) * p0.x) + (2 * negT * t * p1.x) + (Math.pow(t, 2) * p2.x), (Math.pow(negT, 2) * p0.y) + (2 * negT * t * p1.y) + (Math.pow(t, 2) * p2.y));
		//return new Point(calculateTerm(p0.x, p1.x, p2.x, t), calculateTerm(p0.y, p1.y, p2.y, t));
	}
	
}
