package ;
import flash.errors.Error;
import flixel.FlxG;
import flixel.FlxObject;
import flixel.FlxSprite;

/**
 * ...
 * @author Garfunkel
 */
class Person extends FlxSprite
{
	public inline static var AGGR_BEAT = 0.7;
	public inline static var AGGR_HURT = 0.5;
	public inline static var AGGR_NERVOUS = 0.2;
	public inline static var AGGR_OK = -0.2;
	public inline static var AGGR_FRIEND = -0.5;
	public inline static var AGGR_BFF = -0.7;
	var m_width:Int = 32;
	var m_height:Int = 32;
	public var m_bPlayerControlled:Bool = false;
	var m_paceAmount:Int = 0;
	//stats
	public var m_stats:CharacterStats;
	//public var m_name:String;
	//public var m_health:Int = 1000;
	//public var m_physStrength:Int = 10;

	public function new(stats:CharacterStats)
	{
		super(0, 0);
		m_stats = stats;
		loadGraphic("assets/person.png", true, false, m_width, m_height);
		immovable = false;//push people
		//immovable = true;
		maxVelocity.x = 120;
		maxVelocity.y = 120;
		//acceleration.y = 200;
		drag.x = maxVelocity.x * 4;
		drag.y = maxVelocity.y * 4;
		//drag.x = 0;//this makes a character stop immediately, no mario sliding around but megaman.
		//drag.y = 0;
		facing = FlxObject.UP;
		//shrink collision box
		offset.y = 8;
		height = 16;
		offset.x = 8;
		width = 16;
		var afps:Int = 6;
		addAnimation("stand_up", [0],afps);
		addAnimation("walk_up", [1, 0, 2, 0],afps);
		addAnimation("stand_down", [10],afps);
		addAnimation("walk_down", [11, 10, 12, 10],afps);
		addAnimation("stand_right", [20],afps);
		addAnimation("walk_right", [21, 20, 22, 20],afps);
		addAnimation("stand_left", [30],afps);
		addAnimation("walk_left", [31, 30, 32, 30], afps);
		addAnimation("ko", [40], afps);
		//var animNames:List<String>=null;
		//if (index >-1) animNames=LoadAnimations(imageName.substr(0,index+1)+"txt");
	}
	
	public function AttackedBy(p:Person):Void
	{
		var hit:Int = Math.round(p.m_stats.m_physStrength - (m_stats.m_physStrength / 2));
		if (hit <= 0) hit = 1;//always hit a little
		m_stats.m_health -= hit;//should be determined by difference in strength, defense etc..
		if (m_stats.m_health <= 0)
		{
			if (m_bPlayerControlled)
			{
				//FlxG.switchState(new TextState("You were beaten up on your way to school.")); NOT HERE
			}
			else
			{
				//no longer collides, lies down
				solid = false;
				acceleration.x = acceleration.y = 0;
			}
		}
	}
	
	/*public function AcceptsInvitation():Bool
	{
		if (GetAggression() < 0.5) return true;
		return false;
	}
	
	//determine aggression based on stats. 0 is neutral, 1 is 100% aggressive, -1 is 100% best friends
	public function GetAggression():Float
	{
		//return m_stats.GetAggression(GameC
		//return 0.2;
	}*/
	
	override function update():Void
	{
		/*if (m_bPlayerControlled)
		{
			super.update();
			return;
		}*/
		if (solid)
		{
			if (!m_bPlayerControlled)
			{
				try {//cast seems never safe?
						var target:Person = cast(FlxG.state, PlayState).m_player.GetPerson();
					
				//determine direction
				//if agressive or good friend walk towards player (positive aggression
				var aggro:Float = m_stats.GetAggression(target.m_stats);
				//0.7 beating you up
				if (aggro > 0.5)//coming after you, bumping you, getting in the way
				{
					acceleration.x = acceleration.y=0;
						var difX:Float = target.x - x;
						var difY:Float = target.y - y;
						if (Math.abs(difX) > Math.abs(difY))
						{
							//walk left or right
							if (difX>0)//RIGHT
							{
								acceleration.x = maxVelocity.x * 4;
								facing = FlxObject.RIGHT;
							}
							else//LEFT
							{
								acceleration.x = -maxVelocity.x * 4;
								facing = FlxObject.LEFT;
							}
						}
						else
						{
							//walk up or down
							if (difY>0)//DOWN
							{
								acceleration.y = maxVelocity.y * 4;
								facing = FlxObject.DOWN;
							}
							else//UP
							{
								acceleration.y = -maxVelocity.y * 4;
								facing = FlxObject.UP;
							}
						}
					
				}
				else if (aggro > 0.2)//pacing randomly, slightly restless
				{
					if (m_paceAmount == 0)
					{
						acceleration.x = acceleration.y=0;
						var random:Float = Math.random();
						if (random > 0.9)
						{
							acceleration.x = maxVelocity.x * 4;
							facing = FlxObject.RIGHT;
						}
						else if (random > 0.8)
						{
							acceleration.x = -maxVelocity.x * 4;
							facing = FlxObject.LEFT;
						}
						else if (random > 0.7)
						{
							acceleration.y = maxVelocity.y * 4;
							facing = FlxObject.DOWN;
						}
						else if (random > 0.6)
						{
							acceleration.y = -maxVelocity.y * 4;
							facing = FlxObject.UP;
						}
						m_paceAmount = 30;
					}
					m_paceAmount--;
				}
				else
				{
					acceleration.x = acceleration.y=0;
				}
				} catch (err:Error) { }
			}
			//animate
			switch (facing)
			{
				case FlxObject.LEFT:
				{
					if (velocity.x!=0) play("walk_left");
					else play("stand_left");
				}
				case FlxObject.RIGHT:
				{
					if (velocity.x!=0) play("walk_right");
					else play("stand_right");
				}
				case FlxObject.UP:
				{
					if (velocity.y!=0) play("walk_up");
					else play("stand_up");
				}
				case FlxObject.DOWN:
				{
					if (velocity.y!=0) play("walk_down");
					else play("stand_down");
				}
			}
		}
		else
		{
			play("ko");
		}
		/*switch (facing)
		{
			case FlxObject.UP:
			{
				play("stand_up");
			}
			case FlxObject.DOWN:
			{
				play("stand_down");
			}
			case FlxObject.LEFT, FlxObject.RIGHT:
			{
				play("stand_right");
			}
		}*/
		super.update();
	}
	
}