package ;

import flash.display.BitmapData;
import flash.errors.Error;
import flash.geom.ColorTransform;
import flash.geom.Point;
import flash.geom.Rectangle;
import flash.Lib;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flixel.FlxBasic;
import flixel.FlxCamera;
import flixel.FlxG;
import flixel.FlxObject;
import flixel.FlxState;
import flixel.group.FlxGroup;
import flixel.tile.FlxTilemap;
import flixel.util.FlxRect;
import openfl.Assets;

class PlayState extends FlxState 
{
	public var m_player:Player;
	var m_peopleGroup:FlxGroup;
	var m_map:FlxTilemap;
	var m_exit:Rectangle;
	var m_inviting:Person = null;
	var m_message:TextField;
	
	override public function create():Void
	{
		super.create();
		FlxG.mouse.useSystemCursor = true;
		//reset invitation+health
		GameClass.m_instance.m_invitations = new Array();
		GameClass.m_instance.m_playerStats.m_health = 1000;
		for (stats in GameClass.m_instance.m_stats)
		{
			stats.m_health = 1000;
		}
		
		m_message = GameClass.m_instance.CreateTextField();
		m_message.width = FlxG.stage.stageWidth;
		m_message.height = FlxG.stage.stageHeight;
		m_message.wordWrap = true;
		m_message.autoSize = TextFieldAutoSize.CENTER;
		m_message.background = false;
		m_message.textColor = 0xffffff;
		m_message.mouseEnabled = false;
		Lib.current.stage.addChild(m_message);
		//background
		m_map = new FlxTilemap();
		m_map.loadMap(Assets.getText("assets/map.txt"), "assets/background.png", 32, 32, 0, 0, 0, 0);
		var collisions:Array<Int> = [1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
		for (i in 0...collisions.length)
		{
			m_map.setTileProperties(i, (collisions[i] == 1)?FlxObject.ANY:FlxObject.NONE);
		}
		m_map.x = m_map.y = 0;
		m_map.scrollFactor.x = m_map.scrollFactor.y = 1;
		add(m_map);
		m_exit=new Rectangle(190, 0, 130, 60);//based on map
		//people
		var offsetx:Int = 128;
		var offsety:Int = 768;
		m_peopleGroup = new FlxGroup();
		//var names:Array<String> = ["Tobias", "Janosch", "Iwan", "Martha", "Sjors", "Christiaan", "Rita", "Ludwig", "Max", "Andree", "Fabian", "Andy", "Addy", "Benjamin", "Christian"];
		for (stats in GameClass.m_instance.m_stats)
		{
			//var pos:Int = Math.floor(Math.random() * names.length);
			var p:Person = new Person(stats);
			p.x = Math.floor(Math.random() * m_map.width-64)+32;
			p.y = Math.floor(Math.random() * m_map.height-64)+32;
			m_peopleGroup.add(p);
		}
		add(m_peopleGroup);
		//player
		var p:Person = new Person(GameClass.m_instance.m_playerStats);
		p.x = 120+offsetx;
		p.y = 160+offsety;
		//p.m_physStrength = 100;
		m_player = new Player(p);
		add(p);
		//camera n stuff
		FlxG.worldBounds.set(0, 0, m_map.width, m_map.height);
		FlxG.camera.setBounds(0, 0, m_map.width, m_map.height, true);
		FlxG.camera.follow(p, FlxCamera.STYLE_TOPDOWN);
	}
	
	override public function destroy():Void
	{
		remove(m_peopleGroup);
		m_peopleGroup.destroy();
		m_peopleGroup = null;
		var p:Person = m_player.GetPerson();
		remove(p);
		p.destroy();
		p = null;
		m_player.destroy();
		m_player = null;
		super.destroy();
	}
	
	override public function update():Void
	{
		if (FlxG.paused == false)
		{
			var p:Person = m_player.GetPerson();
			if (m_inviting == null)
			{
				if (FlxG.keys.justPressed.SPACE)
				{
					//invite
					var radius:Int = 64;
					var p1:Point = new Point(p.x, p.y);
					for (m in m_peopleGroup.members)
					{
						try
						{
							var person:Person = cast(m, Person);
							if (Lambda.indexOf(GameClass.m_instance.m_invitations, person.m_stats) == -1)
							{
								if (Point.distance(p1, new Point(person.x, person.y)) < radius)
								{
									m_inviting = person;
									if (person.m_stats.AcceptsInvitation(p.m_stats))
									{
										m_message.text = "You invited " + person.m_stats.m_name + ".\nAnd it was accepted!";
										GameClass.m_instance.m_invitations.push(person.m_stats);
									}
									else m_message.text = "You invited " + person.m_stats.m_name + ".\nBut it was declined.";
									m_message.visible = true;
									break;
								}
							}
						} catch (err:Error) {}
					}
				}
				super.update();
				m_player.update();
				if (m_exit.contains(p.x,p.y))
				{
					Finish("You made it to school today.");
				}
				else
				{
					FlxG.collide(p, m_peopleGroup,OnCollideWithPerson);
					FlxG.collide(m_peopleGroup, m_peopleGroup);
					FlxG.collide(m_peopleGroup, m_map);
					FlxG.collide(p, m_map);
				}
			}
			else
			{
				//handle invitation
				if (FlxG.keys.justPressed.SPACE)
				{
					m_message.visible = false;
					m_inviting = null;
				}
			}
		}
	}
	
	function OnCollideWithPerson(player:FlxBasic,person:FlxBasic):Void
	{
		try {
			var playerPerson:Person = m_player.GetPerson();
			var p:Person = cast(person, Person);
			var aggro:Float = p.m_stats.GetAggression(playerPerson.m_stats);
			if (aggro > 0.5)
			{
				p.AttackedBy(playerPerson);
				playerPerson.AttackedBy(p);
				if (playerPerson.m_stats.m_health<=0) Finish("You were beaten up on your way to school.");
			}
		} catch (err:Error) { };
	}
	
	function Finish(text:String):Void
	{
		var spareTimeText:String="School time is over for today, \nwhat do you want to do?";
		if (GameClass.m_instance.m_invitations.length > 0)
		{
			spareTimeText = "School time is over for today, \nyou invited ";
			for (m in GameClass.m_instance.m_invitations)
			{
				spareTimeText += m.m_name+",";
			}
			spareTimeText += "\nwhat do you want to do?";
		}
		FlxG.switchState(new TextState(text,new SparetimeState(spareTimeText)));
	}
	
}