package ;

import openfl.Assets;
import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.Sprite;
import flash.errors.Error;
import flash.events.Event;
import flash.Lib;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flixel.FlxG;
import flixel.FlxState;

class TextState extends FlxState 
{
	var m_optionsYOffset:Int = 0;
	var m_floatyCounter:Float = 0;
	var m_options:TextField;
	var m_message:TextField;
	var m_nextState:FlxState;
	
	public function new(msg:String,nextState:FlxState)
	{
		super();
		m_nextState = nextState;
		m_message = GameClass.m_instance.CreateTextField();
		m_message.text = msg;
	}
	
	override public function create():Void
	{
		super.create();
		FlxG.mouse.useSystemCursor = true;
		
		m_message.width = FlxG.stage.stageWidth;
		m_message.height = FlxG.stage.stageHeight;
		m_message.wordWrap = true;
		m_message.autoSize = TextFieldAutoSize.CENTER;
		m_message.background = false;
		m_message.textColor = 0xffffff;
		m_message.mouseEnabled = false;
		Lib.current.stage.addChild(m_message);
		
		m_options = GameClass.m_instance.CreateTextField();
		m_options.wordWrap = false;
		m_options.text = "Press Space to continue";
		m_options.autoSize = TextFieldAutoSize.LEFT;
		m_options.background = false;
		m_options.textColor = 0xffffff;
		m_options.mouseEnabled = false;
		Lib.current.stage.addChild(m_options);
		
		OnResize(null);
	}
	
	override public function destroy():Void
	{
		Lib.current.stage.removeChild(m_options);
		m_options = null;
		Lib.current.stage.removeChild(m_message);
		m_message = null;
		super.destroy();
	}
	
	function OnResize(e:Event):Void
	{
		m_message.x = 0;
		m_message.y = 0;
		m_options.x = Lib.current.stage.stageWidth - m_options.width - 10;
		m_options.y = m_optionsYOffset=Std.int(Lib.current.stage.stageHeight-m_options.height-10);
	}
	
	override public function update():Void
	{
		//check input
		if (FlxG.keys.justPressed.SPACE)
		{
			FlxG.switchState(m_nextState);
		}
		//move text
		m_options.y = m_optionsYOffset+(Math.sin(m_floatyCounter)*5);
		m_floatyCounter += 0.1;
		if (m_floatyCounter >= 314)//pi
		{
			m_floatyCounter = 0;
			m_options.y = m_optionsYOffset;
		}
	}
	
}